/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package doubleSlit;

import java.util.Random;

/**
 *
 * @author Mikulas_s_capicu
 */
class RiadiaciThread3 extends Thread {
    
    private DoubleSlitCanvas canvas;
    private RiadiaciThread2 thread;
    boolean koniec = false;

    private double vlnovaDlzka = 1.6856 * Math.pow(10, -9);
    private double k = 2 * Math.PI / vlnovaDlzka;
    private Vektor r1 = new Vektor(0,4);
    private Vektor r2 = new Vektor(0,0);
    private Vektor[] vektory = new Vektor[23];
    private double[] pravdepodobnosti = new double[23];

    RiadiaciThread3(DoubleSlitCanvas c, RiadiaciThread2 t ){
        canvas = c;
        thread = t;

        inicializujVektory();
        vyratajVsetkyPravdepodobnosti();
        double konst = najdiMultiplikativnuKonstantu();
        for(int i=0;i<pravdepodobnosti.length;i++){
            pravdepodobnosti[i] *= konst;
        }
    }

    @Override
    public void run() {
        int sirka = canvas.getSize().width;
        canvas.uvodnaAnimacia = true;
        canvas.vykreslenaPlatna = false;
        canvas.dlzkaStrany = -1;
        //canvas.elektronX = -1;
        //canvas.elektronY = -1;
        Random random = new Random();
        Random random2 = new Random();
        while( canvas.dlzkaStrany < canvas.getWidth() - 1 ){
            if (koniec){
                canvas.dlzkaStrany = -1;
                canvas.repaint();
                return;
            }
            canvas.dlzkaStrany += 1;
            try {
                sleep(3);
            } catch (InterruptedException ex) {
                System.out.println(ex.getMessage());
            }
            canvas.repaint();
        }
        canvas.uvodnaAnimacia = false;
        thread.nastavTread(this);
        thread.start();
        try {
            sleep(20000);
        } catch (InterruptedException ex) {
            
        }
        int milis = 0;
        int nanos = 0;
        while (!koniec){
            double rn = Math.random();
            int x = 1 + random.nextInt(sirka-2);
            int y = 10 + 10 * vratSuradnicuDopadu(rn) + random2.nextInt(10);
            canvas.pridajPoziciuElektronu(x, y);
            canvas.repaint();
            try {
                milis = (int) canvas.pauza;
                nanos = (int) ((canvas.pauza - milis) * 1000000);
                sleep(milis,nanos);
            } catch (InterruptedException ex) {
                System.out.println(ex.getMessage());
            }
        }
    }

    private double vyratajPravdebodobnostDopadu(Vektor r){
        Vektor rr1 = r.copy();
        Vektor rr2 = r.copy();

        rr1.odcitajVektor(r1);
        rr2.odcitajVektor(r2);
        double velkostRR1 = rr1.velkostVektora();
        double velkostRR2 = rr2.velkostVektora();
        double realnaCast = ( Math.cos(k*velkostRR1)/Math.sqrt(velkostRR1) ) + ( Math.cos(k*velkostRR2)/Math.sqrt(velkostRR2) );
        double imaginarnaCast = ( Math.sin(k*velkostRR1)/Math.sqrt(velkostRR1) ) + ( Math.sin(k*velkostRR2)/Math.sqrt(velkostRR2) );

        double vysledok = Math.pow(realnaCast, 2) + Math.pow(imaginarnaCast, 2);
        return vysledok;

    }

    private void inicializujVektory(){
       int koef = vektory.length/2;
       for(int i=0;i<vektory.length;i++){
            vektory[i] = new Vektor(30,2-koef+i);
       }
    }

    private void vyratajVsetkyPravdepodobnosti(){
       for(int i=0;i<vektory.length;i++){
            pravdepodobnosti[i] = vyratajPravdebodobnostDopadu(vektory[i]);
       }
    }

    private double najdiMultiplikativnuKonstantu(){
        double sum=0;
        for(int i=0;i<pravdepodobnosti.length;i++){
           sum += pravdepodobnosti[i];
        }
        return 1 / sum;
    }

    private int vratSuradnicuDopadu(double a){
        int suradnica = 0;
        double velkost = pravdepodobnosti[0];
        while(a>velkost){
            suradnica++;
            velkost += pravdepodobnosti[suradnica];
        }
        return suradnica;
    }

}