/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package hlavny;

import java.io.IOException;
import java.io.OutputStream;
import java.net.Socket;
import java.util.HashSet;
import java.util.Iterator;

/**
 *
 * @author Mikulas_s_capicu
 */
public class Zapisovac {

    final HashSet<Socket> sockety;

    public Zapisovac(HashSet<Socket> col){
        sockety = col;
    }
    
    public void startSignal(){
        posliSpravu("START");
    }

    public void stopSignal(){
        posliSpravu("STOP");
    }

    public void pushSignal(String button){
        posliSpravu("PUSH"+button);
    }

    public void setSignal(String s, String hodnota){
        posliSpravu("SET"+s+","+hodnota);
    }

    public void expSignal(String exp){
        posliSpravu("EXP"+exp);
    }

    void unsyncSignal(Socket s){
        try {
            OutputStream os =s.getOutputStream();

            byte bts[] = "UNSYNC".getBytes();
	    os.write(bts.length & 255);
	    os.write(bts.length >> 8);
	    os.write(bts, 0, bts.length);

	    os.flush();
       }catch (IOException e) {
            System.err.println("Nepodarilo sa poslat spravu");
       }
    }

    private void posliSpravu(String message){
	byte bts[] = message.getBytes();

            synchronized(sockety){

                for(Iterator<Socket> it = sockety.iterator();it.hasNext();){
                    Socket soc = it.next();
                    try {
                    OutputStream os =soc.getOutputStream();
	            os.write(bts.length & 255);
		    os.write(bts.length >> 8);
		    os.write(bts, 0, bts.length);
		    os.flush();
                    }catch (IOException e) {
                         System.err.println("Nepodarilo sa poslat spravu");
                         try {
                            soc.close();
                         } catch (IOException ex) {
                            System.err.println("Zapisovac: Nepodarilo sa zavriet socket");
                         }
                         it.remove();
                    }
                }

	    }
    }

}
