/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package fotoefekt;

/**
 *
 * @author Mikulas_s_capicu
 */
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.net.URL;
import javax.imageio.ImageIO;

public class FotoefektCanvas extends Canvas {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

        private Color[] farbaKatody = {Color.GRAY, Color.DARK_GRAY, Color.YELLOW, Color.RED};
        int aktualnyKov = 0;
        boolean animujLuce = false;
        //boolean animujElektrony = false;
        int lampaX = 506;  //umiestnenie odkial budu vychadzat luce
        int lampaY = 57;
        SvetelnyLuc[] luce = new SvetelnyLuc[10];
        int pocetLucov = 0; //kolko lucov sa bude vykreslovat
        private Image aparatura;
        Elektron[] elektrony = new Elektron[10];
        int poziciaAnody = 464;
        private boolean pripravenyBuffer = false;
        private Image offscreen = null;
        private Graphics bufferGraphics = null;
        Point[] konceRucicky = {new Point(630, 243), new Point(634, 240), new Point(639, 237),
                                new Point(644, 236), new Point(649, 234), new Point(655, 234),
                                new Point(661, 234), new Point(667, 236), new Point(672, 237),
                                new Point(677, 241), new Point(681, 244)};
        int indexKoncaRucicky = 0;

        public FotoefektCanvas(){
           for(int i=0;i<10;i++){
             luce[i] = new SvetelnyLuc(lampaX, lampaY);
             elektrony[i] = new Elektron(189, 154+14*i);
           }
           try{
               URL cesta = getClass().getResource("fotoefekt_aparatura.png");
               aparatura = ImageIO.read(cesta);
           }catch(Exception e){
               System.out.println(e.getMessage());
           }
        }

	@Override
	public void paint(Graphics g) {
                if( ! pripravenyBuffer){
                    offscreen = createImage(getSize().width, getSize().height);
                    bufferGraphics = offscreen.getGraphics();
                    pripravenyBuffer = true;
                }

                vycistiPlochu();
		bufferGraphics.drawImage(aparatura, 0, 0, this);
                vykresliKatodu(bufferGraphics);
                vykresliElektrony(bufferGraphics);
                vykresliRucicku(bufferGraphics);
                            
                if (animujLuce){
                  for(int i=0;i<pocetLucov;i++){
                    bufferGraphics.drawImage(luce[i].obrazok,  (int) luce[i].x,
                                             (int) luce[i].y, this);
                  }
                }

                g.drawImage(offscreen, 0, 0, this);
                                
	}

        @Override
	public void update(Graphics g) {
		paint(g);
	}

    private void vykresliKatodu(Graphics g) {
        Color c = g.getColor();
        g.setColor(farbaKatody[aktualnyKov]);
        g.fillRect(169, 146, 25, 144);
        g.setColor(c);
    }

    private void vykresliElektrony(Graphics g) {
        Color c = g.getColor();
        g.setColor(Color.BLUE);
        for(int i=0;i<10;i++){
          g.fillOval((int) elektrony[i].x-5, (int) elektrony[i].y-5, 10, 10);
        }
        g.setColor(c);
    }

    private void vycistiPlochu(){
        Dimension size = getSize();
        bufferGraphics.clearRect(0, 0, size.width, size.height);
    }

    private void vykresliRucicku(Graphics g) {
        g.drawLine(656, 272, konceRucicky[indexKoncaRucicky].x, konceRucicky[indexKoncaRucicky].y);
    }

}
