/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package rutherford;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.net.URL;
import java.util.HashSet;
import java.util.Iterator;
import javax.imageio.ImageIO;

/**
 *
 * @author Mikulas_s_capicu
 */
public class RutherfordCanvas extends Canvas {

    private Image aparatura, folia;
    private HashSet<AlfaCastica> alfaCastice = new HashSet<AlfaCastica>();
    private HashSet<DetailCastica> detailCastice = new HashSet<DetailCastica>();
    int polomer = 3;
    boolean kresliDetail = false;
    boolean typ = false;

    public RutherfordCanvas(){
         try {
            URL cesta = getClass().getResource("Rutheford_aparatura.png");
            aparatura = ImageIO.read(cesta);
         } catch (Exception e) {
            System.out.println("Neda sa najst obrazok aparatury");
         }
         try {
            URL cesta = getClass().getResource("folia.png");
            folia = ImageIO.read(cesta);
         } catch (Exception e) {
            System.out.println("Neda sa najst obrazok folie");
         }
    }

    @Override
    public void paint(Graphics g) {
        Dimension size = getSize();
        Image offscreen = createImage(size.width, size.height);
        Graphics bufferGraphics = offscreen.getGraphics();

        bufferGraphics.drawImage(aparatura, 0, 0, this);
        
        vykresliCastice(bufferGraphics);

        if (kresliDetail){
            bufferGraphics.drawImage(folia, 576, 0, this);
            vykresliDetailCastice(bufferGraphics);
        }

        g.drawImage(offscreen, 0, 0, this);
    }

    @Override
    public void update(Graphics g) {
        paint(g);
    }

    synchronized void vykresliCastice(Graphics g){
        for(Iterator<AlfaCastica> it = alfaCastice.iterator();it.hasNext();){
                AlfaCastica pom = it.next();
                if (pom.dosiahlaTienidlo){
                    g.setColor(Color.yellow);
                    g.fillOval((int) pom.x-5, (int) pom.y-5, 10, 10);
                    pom.zobrazilaSaNaTienidle++;
                }else{
                    g.setColor(Color.red);
                    g.fillOval((int) pom.x-polomer, (int) pom.y-polomer, 2*polomer, 2*polomer);
                }
        }
    }

    synchronized void vykresliDetailCastice(Graphics g){
        g.translate(576, 0);
        for(Iterator<DetailCastica> it = detailCastice.iterator();it.hasNext();){
                DetailCastica pom = it.next();
                g.setColor(pom.farba);
                g.fillOval((int) (pom.x-pom.polomer),(int) (pom.y-pom.polomer),
                           (int) (2*pom.polomer) ,  (int) (2*pom.polomer) );
        }
        g.translate(0, 0);
    }

    synchronized void posunDetailCastice(){
        for(Iterator<DetailCastica> it = detailCastice.iterator();it.hasNext();){
                DetailCastica pom = it.next();
                pom.posunCasticu();
                if ((pom.x<0) || (pom.x >202) ){
                    it.remove();
                    continue;
                }
                if ((pom.y<0) || (pom.y >269) ){
                    it.remove();
                    continue;
                }
                if ((pom.polomer >15) || (pom.polomer < 0)){
                    it.remove();
                    continue;
                }
                if (pom.polomer == 6){
                    pom.nastavNoveZmeny();
                }
        }
    }

    synchronized void posunCastice(){
        for(Iterator<AlfaCastica> it = alfaCastice.iterator();it.hasNext();){
                    AlfaCastica pom = it.next();
                    pom.posunCasticu();
                    if (pom.x == 5){
                        it.remove();
                        continue;
                    }
                    if ( (pom.y == 96) || (pom.y == 178) ){
                        it.remove();
                        continue;
                    }
                    if (pom.x == 99){
                        if (pom.y != 136){
                            it.remove();
                            continue;
                        }
                    }
                    if (pom.x == 431){
                        pom.nastavNovuDeltu();
                        continue;
                    }
                    if (pom.zobrazilaSaNaTienidle > 5){
                        it.remove();
                        continue;
                    }
                    if ((pom.x == 387) && (pom.dx == 1) && typ){
                        DetailCastica det = new DetailCastica(pom);
                        detailCastice.add(det);
                    }
                    if ((pom.x != 300) && (vzdialenostOdFolie(pom) == 131)){
                        pom.dosiahlaTienidlo = true;
                        pom.dx = 0;
                        pom.dy = 0;
                    }
                }
    }

    synchronized void vymazVsetkyCastice(){
        alfaCastice.clear();
        detailCastice.clear();
    }

    synchronized void pridajCasticu(AlfaCastica castica){
        alfaCastice.add(castica);
    }

    private int vzdialenostOdFolie(AlfaCastica pom) {
        double suradnicaX = pom.x - 431;
        double suradnicaY = pom.y - 136;
        return (int) Math.sqrt(Math.pow(suradnicaX,2) + Math.pow(suradnicaY,2));
    }

}